#include <bits/stdc++.h>

using namespace std;

int N,M,prvi,drugi,niz[100001];
int main(){
    cin>>N>>M;
    for(int i=1; i<=N; i++)
        cin>>niz[i];
   for (int i=1; i<=M; i++)
        cin>>prvi>>drugi;
        cout<<max ({niz[prvi]+niz[drugi],-niz[prvi]-niz[drugi]})<<endl;
    return 0;
}